Index: /trunk/src/sys/arch/sgimips/hpc/panel.c
===================================================================
--- /trunk/src/sys/arch/sgimips/hpc/panel.c	(revision 151)
+++ /trunk/src/sys/arch/sgimips/hpc/panel.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: panel.c,v 1.1.4.2 2009/09/26 18:03:06 snj Exp $ */
+/*	$NetBSD: panel.c,v 1.1.10.2 2010/12/29 07:19:28 matt Exp $ */
 
 /*-
@@ -28,5 +28,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: panel.c,v 1.1.4.2 2009/09/26 18:03:06 snj Exp $");
+__KERNEL_RCSID(0, "$NetBSD: panel.c,v 1.1.10.2 2010/12/29 07:19:28 matt Exp $");
 
 #include <sys/param.h>
Index: /trunk/src/sys/arch/sgimips/include/intr.h
===================================================================
--- /trunk/src/sys/arch/sgimips/include/intr.h	(revision 151)
+++ /trunk/src/sys/arch/sgimips/include/intr.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: intr.h,v 1.25.36.1 2010/02/06 02:57:44 matt Exp $	*/
+/*	$NetBSD: intr.h,v 1.25.36.2 2010/12/29 07:15:47 matt Exp $	*/
 
 /*
@@ -36,27 +36,12 @@
 #define	_SGIMIPS_INTR_H_
 
-#define	IPL_NONE	0	/* Disable only this interrupt. */
-#define	IPL_SOFTCLOCK	1	/* generic software interrupts */
-#define	IPL_SOFTBIO	1	/* serial software interrupts */
-#define	IPL_SOFTNET	1	/* network software interrupts */
-#define	IPL_SOFTSERIAL	1	/* clock software interrupts */
-#define	IPL_VM		2
-#define	IPL_SCHED	3
-#define	IPL_HIGH	4
-
-#define NIPL		5
-
-/* Interrupt sharing types. */
-#define IST_NONE	0	/* none */
-#define IST_PULSE	1	/* pulsed */
-#define IST_EDGE	2	/* edge-triggered */
-#define IST_LEVEL	3	/* level-triggered */
+#include <mips/intr.h>
 
 #ifdef _KERNEL
-#ifndef _LOCORE
+#ifdef __INTR_PRIVATE
 
 #include <sys/queue.h>
 #include <sys/types.h>
-#include <sys/device.h>
+#include <sys/evcnt.h>
 #include <mips/cpuregs.h>
 #include <mips/locore.h>
@@ -65,6 +50,5 @@
 
 struct sgimips_intrhand {
-	LIST_ENTRY(sgimips_intrhand)
-		ih_q;
+	LIST_ENTRY(sgimips_intrhand) ih_q;
 	int	(*ih_fun) (void *);
 	void	 *ih_arg;
@@ -75,6 +59,5 @@
 
 struct sgimips_intr {
-	LIST_HEAD(,sgimips_intrhand)
-		intr_q;
+	LIST_HEAD(,sgimips_intrhand) intr_q;
 	struct	evcnt ih_evcnt;
 	unsigned long intr_ipl;
@@ -83,33 +66,9 @@
 extern struct sgimips_intrhand intrtab[];
 
-extern const int *ipl2spl_table;
+#endif /* __INTR_PRIVATE */
 
-#define spl0()		(void)_spllower(0)
-#define splx(s)		(void)_splset(s)
-#define splvm()		_splraise(ipl2spl_table[IPL_VM])
-#define splsched()	_splraise(ipl2spl_table[IPL_SCHED])
-#define splhigh()	_splraise(MIPS_INT_MASK)
-
-#define splsoftclock()	_splraise(MIPS_SOFT_INT_MASK_1)
-#define splsoftbio()	splsoftclock()
-#define splsoftnet()	splsoftclock()
-#define splsoftserial()	splsoftclock()
-
-extern void *		cpu_intr_establish(int, int, int (*)(void *), void *);
-
-typedef int ipl_t;
-typedef struct {
-	int _spl;
-} ipl_cookie_t;
-
-ipl_cookie_t makeiplcookie(ipl_t);
-
-static inline int
-splraiseipl(ipl_cookie_t icookie)
-{
-
-	return _splraise(icookie._spl);
-}
-#endif /* _LOCORE */
+#ifndef _LOCORE
+void *cpu_intr_establish(int, int, int (*)(void *), void *);
+#endif
 #endif /* !_KERNEL */
 
Index: /trunk/src/sys/arch/sgimips/include/sysconf.h
===================================================================
--- /trunk/src/sys/arch/sgimips/include/sysconf.h	(revision 151)
+++ /trunk/src/sys/arch/sgimips/include/sysconf.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: sysconf.h,v 1.7 2006/12/29 05:26:30 rumble Exp $	*/
+/*	$NetBSD: sysconf.h,v 1.7.66.1 2010/12/29 07:15:47 matt Exp $	*/
 
 /*
@@ -76,10 +76,10 @@
 	void	(*watchdog_disable)(void);
 	void	(*watchdog_enable)(void);
-	void	(*intr0)(u_int32_t, u_int32_t, u_int32_t, u_int32_t);
-	void	(*intr1)(u_int32_t, u_int32_t, u_int32_t, u_int32_t);
-	void	(*intr2)(u_int32_t, u_int32_t, u_int32_t, u_int32_t);
-	void	(*intr3)(u_int32_t, u_int32_t, u_int32_t, u_int32_t);
-	void	(*intr4)(u_int32_t, u_int32_t, u_int32_t, u_int32_t);
-	void	(*intr5)(u_int32_t, u_int32_t, u_int32_t, u_int32_t);
+	void	(*intr0)(vaddr_t, uint32_t, uint32_t);
+	void	(*intr1)(vaddr_t, uint32_t, uint32_t);
+	void	(*intr2)(vaddr_t, uint32_t, uint32_t);
+	void	(*intr3)(vaddr_t, uint32_t, uint32_t);
+	void	(*intr4)(vaddr_t, uint32_t, uint32_t);
+	void	(*intr5)(vaddr_t, uint32_t, uint32_t);
 };
 
Index: /trunk/src/sys/arch/sgimips/ioc/ioc.c
===================================================================
--- /trunk/src/sys/arch/sgimips/ioc/ioc.c	(revision 151)
+++ /trunk/src/sys/arch/sgimips/ioc/ioc.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: ioc.c,v 1.7 2007/10/17 19:57:05 garbled Exp $	 */
+/* $NetBSD: ioc.c,v 1.7.38.1 2010/12/29 07:19:28 matt Exp $	 */
 
 /*
@@ -38,5 +38,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: ioc.c,v 1.7 2007/10/17 19:57:05 garbled Exp $");
+__KERNEL_RCSID(0, "$NetBSD: ioc.c,v 1.7.38.1 2010/12/29 07:19:28 matt Exp $");
 
 #include <sys/param.h>
@@ -141,8 +141,11 @@
 			  IOC_WRITE_PC_UART2 | IOC_WRITE_PC_UART1);
 
+/* XXX: the firmware should have taken care of this already */
+#if 0
 	if (mach_subtype == MACH_SGI_IP22_GUINNESS) {
 		bus_space_write_4(sc->sc_iot, sc->sc_ioh, IOC_GCSEL, 0xff);
 		bus_space_write_4(sc->sc_iot, sc->sc_ioh, IOC_GCREG, 0xff);
 	}
+#endif
 
 #if defined(BLINK)
Index: /trunk/src/sys/arch/sgimips/sgimips/clock.c
===================================================================
--- /trunk/src/sys/arch/sgimips/sgimips/clock.c	(revision 151)
+++ /trunk/src/sys/arch/sgimips/sgimips/clock.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: clock.c,v 1.20 2006/12/29 07:00:11 rumble Exp $	*/
+/*	$NetBSD: clock.c,v 1.20.66.1 2010/12/29 07:15:48 matt Exp $	*/
 
 /*
@@ -80,5 +80,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: clock.c,v 1.20 2006/12/29 07:00:11 rumble Exp $");
+__KERNEL_RCSID(0, "$NetBSD: clock.c,v 1.20.66.1 2010/12/29 07:15:48 matt Exp $");
 
 #include <sys/param.h>
@@ -86,4 +86,5 @@
 #include <sys/kernel.h>
 #include <sys/systm.h>
+#include <sys/cpu.h>
 #include <machine/sysconf.h>
 
@@ -96,8 +97,8 @@
 #include <sgimips/sgimips/clockvar.h>
 
-u_int32_t next_clk_intr;
-u_int32_t missed_clk_intrs;
+uint32_t next_clk_intr;
+uint32_t missed_clk_intrs;
 
-void mips3_clock_intr(u_int32_t, u_int32_t, u_int32_t, u_int32_t);
+void mips3_clock_intr(vaddr_t, uint32_t, uint32_t);
 
 /*
@@ -130,5 +131,5 @@
 		/* int(4) will take care of our clocks */
 		/* enable hardware interrupts including hardclock(9) */
-		_splnone();
+		spl0();
 		break;
 #endif /* MIPS1 */
@@ -149,6 +150,5 @@
 #if defined(MIPS3)
 void
-mips3_clock_intr(u_int32_t status, u_int32_t cause, u_int32_t pc,
-		 u_int32_t ipending)
+mips3_clock_intr(vaddr_t pc, uint32_t status, uint32_t pending)
 {
 	struct clockframe cf;
@@ -156,4 +156,5 @@
 	cf.pc = pc;
 	cf.sr = status;
+	cf.intr = (curcpu()->ci_idepth > 1);
 	mips3_clockintr(&cf);
 }
Index: /trunk/src/sys/arch/sgimips/sgimips/cpu.c
===================================================================
--- /trunk/src/sys/arch/sgimips/sgimips/cpu.c	(revision 151)
+++ /trunk/src/sys/arch/sgimips/sgimips/cpu.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: cpu.c,v 1.21.36.3 2010/02/05 07:39:54 matt Exp $	*/
+/*	$NetBSD: cpu.c,v 1.21.36.4 2010/12/29 07:15:48 matt Exp $	*/
 
 /*
@@ -36,5 +36,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: cpu.c,v 1.21.36.3 2010/02/05 07:39:54 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: cpu.c,v 1.21.36.4 2010/12/29 07:15:48 matt Exp $");
 
 #include <sys/param.h>
@@ -56,9 +56,7 @@
 static int	cpu_match(struct device *, struct cfdata *, void *);
 static void	cpu_attach(struct device *, struct device *, void *);
-void		cpu_intr(u_int32_t, u_int32_t, vaddr_t, u_int32_t);
+void		cpu_intr(int, vaddr_t, uint32_t);
 void *cpu_intr_establish(int, int, int (*func)(void *), void *);
-void		mips1_fpu_intr(u_int32_t, u_int32_t, u_int32_t, u_int32_t);
-
-void	MachFPInterrupt(u_int32_t, u_int32_t, u_int32_t, struct trapframe *);
+void		mips1_fpu_intr(vaddr_t, u_int32_t, u_int32_t);
 
 static struct evcnt mips_int0_evcnt =
@@ -79,7 +77,4 @@
 static struct evcnt mips_int5_evcnt =
 	EVCNT_INITIALIZER(EVCNT_TYPE_INTR, NULL, "mips", "int 5");
-
-static struct evcnt mips_spurint_evcnt =
-	EVCNT_INITIALIZER(EVCNT_TYPE_INTR, NULL, "mips", "spurious interrupts");
 
 CFATTACH_DECL_NEW(cpu, 0,
@@ -109,63 +104,46 @@
  */
 void
-cpu_intr(u_int32_t status, u_int32_t cause, vaddr_t pc, u_int32_t ipending)
+cpu_intr(int ppl, vaddr_t pc, uint32_t status)
 {
-	struct cpu_info *ci;
+	uint32_t pending;
+	int ipl;
 
-	ci = curcpu();
-	ci->ci_idepth++;
 	uvmexp.intrs++;
 
 	(void)(*platform.watchdog_reset)();
 
-	if (ipending & MIPS_HARD_INT_MASK) {
-        	if (ipending & MIPS_INT_MASK_5) {
-               		(void)(*platform.intr5)(status, cause, pc, ipending);
+	while (ppl < (ipl = splintr(&pending))) {
+		splx(ipl);		/* enable interrupts */
+
+        	if (pending & MIPS_INT_MASK_5) {
+               		(void)(*platform.intr5)(pc, status, pending);
 			mips_int5_evcnt.ev_count++;
-			cause &= ~MIPS_INT_MASK_5;
         	}
 
-		if (ipending & MIPS_INT_MASK_4) {
-			(void)(*platform.intr4)(status, cause, pc, ipending);
+		if (pending & MIPS_INT_MASK_4) {
+               		(void)(*platform.intr4)(pc, status, pending);
 			mips_int4_evcnt.ev_count++;
-			cause &= ~MIPS_INT_MASK_4;
 		}
 
-		if (ipending & MIPS_INT_MASK_3) {
-			(void)(*platform.intr3)(status, cause, pc, ipending);
+		if (pending & MIPS_INT_MASK_3) {
+               		(void)(*platform.intr3)(pc, status, pending);
 			mips_int3_evcnt.ev_count++;
-			cause &= ~MIPS_INT_MASK_3;
 		}
 
-	        if (ipending & MIPS_INT_MASK_2) {
-			(void)(*platform.intr2)(status, cause, pc, ipending);
+	        if (pending & MIPS_INT_MASK_2) {
+               		(void)(*platform.intr2)(pc, status, pending);
 			mips_int2_evcnt.ev_count++;
-			cause &= ~MIPS_INT_MASK_2;
 		}
 
-		if (ipending & MIPS_INT_MASK_1) {
-			(void)(*platform.intr1)(status, cause, pc, ipending);
+		if (pending & MIPS_INT_MASK_1) {
+               		(void)(*platform.intr1)(pc, status, pending);
 			mips_int1_evcnt.ev_count++;
-			cause &= ~MIPS_INT_MASK_1;
 		}
 
-		if (ipending & MIPS_INT_MASK_0) {  
-			(void)(*platform.intr0)(status, cause, pc, ipending);
+		if (pending & MIPS_INT_MASK_0) {  
+               		(void)(*platform.intr0)(pc, status, pending);
 			mips_int0_evcnt.ev_count++;
-			cause &= ~MIPS_INT_MASK_0;
 		}
-
-		if (cause & status & MIPS_HARD_INT_MASK)
-			mips_spurint_evcnt.ev_count++;
 	}
-	ci->ci_idepth--;
-
-#ifdef __HAVE_FAST_SOFTINTS
-	/* software interrupt */
-	ipending &= MIPS_SOFT_INT_MASK;
-	if (ipending == 0)
-		return;
-	softint_process(ipending);
-#endif
 }
 
@@ -177,15 +155,15 @@
 }
 
+#ifdef MIPS1
 void
-mips1_fpu_intr(u_int32_t status, u_int32_t cause, u_int32_t pc,
-    u_int32_t ipending)
+mips1_fpu_intr(vaddr_t pc, uint32_t status, uint32_t pending)
 {
-
 	if (!USERMODE(status))
-		panic("kernel used FPU: PC 0x%08x, CR 0x%08x, SR 0x%08x",
-		    pc, cause, status);
+		panic("kernel used FPU: PC 0x%08x, SR 0x%08x",
+		    pc, status);
 
 #if !defined(NOFPU) && !defined(FPEMUL)
-	MachFPInterrupt(status, cause, pc, curlwp->l_md.md_utf);
+	mips_fpu_intr(pc, curlwp->l_md.md_utf);
 #endif
 }
+#endif
Index: /trunk/src/sys/arch/sgimips/sgimips/machdep.c
===================================================================
--- /trunk/src/sys/arch/sgimips/sgimips/machdep.c	(revision 151)
+++ /trunk/src/sys/arch/sgimips/sgimips/machdep.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: machdep.c,v 1.121.8.5 2010/03/21 17:38:35 cliff Exp $	*/
+/*	$NetBSD: machdep.c,v 1.121.8.6 2010/12/29 07:15:48 matt Exp $	*/
 
 /*
@@ -35,5 +35,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.121.8.5 2010/03/21 17:38:35 cliff Exp $");
+__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.121.8.6 2010/12/29 07:15:48 matt Exp $");
 
 #include "opt_ddb.h"
@@ -42,4 +42,6 @@
 #include "opt_cputype.h"
 #include "opt_mips_cache.h"
+
+#define __INTR_PRIVATE
 
 #include <sys/param.h>
@@ -129,34 +131,37 @@
 int ncpus;
 
-/* CPU interrupt masks */
-const int *ipl2spl_table;
-
-#define	IPL2SPL_TABLE_COMMON \
-	[IPL_SOFTCLOCK] = MIPS_SOFT_INT_MASK_1, \
-	[IPL_HIGH] = MIPS_INT_MASK,
-
+#define IPL2SPL_TABLE_COMMON					\
+	[IPL_NONE] =		0,				\
+	[IPL_SOFTCLOCK] =	MIPS_SOFT_INT_MASK_0,		\
+	[IPL_SOFTNET] =		MIPS_SOFT_INT_MASK,		\
+	[IPL_DDB] =		MIPS_INT_MASK,			\
+	[IPL_HIGH] =		MIPS_INT_MASK
+
+/* CPU interrupt sr maps */
 #if defined(MIPS1)
-static const int sgi_ip12_ipl2spl_table[] = {
-	IPL2SPL_TABLE_COMMON
+static const struct ipl_sr_map sgi_ip12_ipl_sr_map = {
+    .sr_bits = {
+	IPL2SPL_TABLE_COMMON,
 	[IPL_VM] = MIPS_INT_MASK_2|MIPS_INT_MASK_1|MIPS_INT_MASK_0|
-	    MIPS_SOFT_INT_MASK_0,
+	    MIPS_SOFT_INT_MASK,
 	[IPL_SCHED] = MIPS_INT_MASK_4|MIPS_INT_MASK_3|MIPS_INT_MASK_2|
-	    MIPS_INT_MASK_1|MIPS_INT_MASK_0|MIPS_SOFT_INT_MASK_0,
+	    MIPS_INT_MASK_1|MIPS_INT_MASK_0|MIPS_SOFT_INT_MASK,
+    },
 };
 #endif /* defined(MIPS1) */
 #if defined(MIPS3)
-static const int sgi_ip2x_ipl2spl_table[] = {
-	IPL2SPL_TABLE_COMMON
-	[IPL_VM] = MIPS_INT_MASK_1|MIPS_INT_MASK_0|
-	    MIPS_SOFT_INT_MASK_1|MIPS_SOFT_INT_MASK_0,
-	[IPL_SCHED] = MIPS_INT_MASK_5|MIPS_INT_MASK_3|MIPS_INT_MASK_2|
-	    MIPS_INT_MASK_1|MIPS_INT_MASK_0|
-	    MIPS_SOFT_INT_MASK_1|MIPS_SOFT_INT_MASK_0,
+static const struct ipl_sr_map sgi_ip2x_ipl_sr_map = {
+    .sr_bits = {
+	IPL2SPL_TABLE_COMMON,
+	[IPL_VM] = MIPS_INT_MASK_1|MIPS_INT_MASK_0|MIPS_SOFT_INT_MASK,
+	[IPL_SCHED] = MIPS_INT_MASK,
+    },
 };
-static const int sgi_ip3x_ipl2spl_table[] = {
-	IPL2SPL_TABLE_COMMON
-	[IPL_VM] = MIPS_INT_MASK_0|MIPS_SOFT_INT_MASK_1|MIPS_SOFT_INT_MASK_0,
-	[IPL_SCHED] = MIPS_INT_MASK_5|MIPS_INT_MASK_0|
-	    MIPS_SOFT_INT_MASK_1|MIPS_SOFT_INT_MASK_0,
+static const struct ipl_sr_map sgi_ip3x_ipl_sr_map = {
+    .sr_bits = {
+	IPL2SPL_TABLE_COMMON,
+	[IPL_VM] = MIPS_INT_MASK_0|MIPS_SOFT_INT_MASK,
+	[IPL_SCHED] = MIPS_INT_MASK_5|MIPS_INT_MASK_0|MIPS_SOFT_INT_MASK,
+    },
 };
 #endif /* defined(MIPS3) */
@@ -171,9 +176,9 @@
 
 #if defined(MIPS1)
-extern void mips1_fpu_intr(u_int32_t, u_int32_t, u_int32_t, u_int32_t);
+extern void mips1_fpu_intr(vaddr_t, uint32_t, uint32_t);
 #endif
 
 #if defined(MIPS3)
-extern void mips3_clock_intr(u_int32_t, u_int32_t, u_int32_t, u_int32_t);
+extern void mips3_clock_intr(vaddr_t, uint32_t, uint32_t);
 #endif
 
@@ -194,5 +199,5 @@
 static void	unimpl_cons_init(void);
 static void	*unimpl_intr_establish(int, int, int (*)(void *), void *);
-static void	unimpl_intr(u_int32_t, u_int32_t, u_int32_t, u_int32_t);
+static void	unimpl_intr(vaddr_t, uint32_t, uint32_t);
 static unsigned	long nulllong(void);
 static void	nullvoid(void);
@@ -223,5 +228,5 @@
  * autoconfiguration or after a panic.  Used as an argument to splx().
  */
-int	safepri = MIPS1_PSL_LOWIPL;
+int	safepri = IPL_HIGH;
 
 extern u_int32_t ssir;
@@ -523,5 +528,5 @@
                 }
 
-		ipl2spl_table = sgi_ip12_ipl2spl_table;
+		ipl_sr_map = sgi_ip12_ipl_sr_map;
 		platform.intr0 = mips1_fpu_intr;
 		break;
@@ -532,17 +537,17 @@
 		i = *(volatile u_int32_t *)MIPS_PHYS_TO_KSEG1(0x1fbd0000);
 		mach_boardrev = (i & 0x7000) >> 12;
-		ipl2spl_table = sgi_ip2x_ipl2spl_table;
+		ipl_sr_map = sgi_ip2x_ipl_sr_map;
 		platform.intr5 = mips3_clock_intr;
 		break;
 	case MACH_SGI_IP22:
-		ipl2spl_table = sgi_ip2x_ipl2spl_table;
+		ipl_sr_map = sgi_ip2x_ipl_sr_map;
 		platform.intr5 = mips3_clock_intr;
 		break;
 	case MACH_SGI_IP30:
-		ipl2spl_table = sgi_ip3x_ipl2spl_table;
+		ipl_sr_map = sgi_ip3x_ipl_sr_map;
 		platform.intr5 = mips3_clock_intr;
 		break;
 	case MACH_SGI_IP32:
-		ipl2spl_table = sgi_ip3x_ipl2spl_table;
+		ipl_sr_map = sgi_ip3x_ipl_sr_map;
 		platform.intr5 = mips3_clock_intr;
 		break;
@@ -877,15 +882,15 @@
 {
 	panic("target init didn't set intr_establish");
-	return (void *)NULL;
+	return NULL;
 }
 
 static void
-unimpl_intr(u_int32_t status, u_int32_t cause, u_int32_t pc, u_int32_t ipending)
-{
-	printf("spurious interrupt, ipending %x\n", ipending);
+unimpl_intr(vaddr_t pc, uint32_t status, uint32_t pending)
+{
+	printf("spurious interrupt pending %#x\n", pending);
 }
 
 static unsigned long
-nulllong()
+nulllong(void)
 {
 	printf("nulllong\n");
@@ -988,9 +993,2 @@
 	}
 }
-
-ipl_cookie_t
-makeiplcookie(ipl_t ipl)
-{
-
-	return (ipl_cookie_t){._spl = ipl2spl_table[ipl]};
-}
Index: /trunk/src/sys/arch/tsarmips/conf/files.tsarmips
===================================================================
--- /trunk/src/sys/arch/tsarmips/conf/files.tsarmips	(revision 151)
+++ /trunk/src/sys/arch/tsarmips/conf/files.tsarmips	(revision 152)
@@ -72,6 +72,4 @@
 file	dev/cons.c
 
-file arch/mips/mips/softintr.c
-
 #
 # Machine-independent SCSI drivers
Index: /trunk/src/sys/arch/tsarmips/conf/kern.ldscript
===================================================================
--- /trunk/src/sys/arch/tsarmips/conf/kern.ldscript	(revision 151)
+++ /trunk/src/sys/arch/tsarmips/conf/kern.ldscript	(revision 152)
@@ -19,4 +19,7 @@
     *(.text)
     *(.text.*)
+    __stub_start = . ;
+    *(.stub*)
+    __stub_end = . ;
     *(.gnu.warning)
   } =0
Index: /trunk/src/sys/arch/tsarmips/include/bus.h
===================================================================
--- /trunk/src/sys/arch/tsarmips/include/bus.h	(revision 151)
+++ /trunk/src/sys/arch/tsarmips/include/bus.h	(revision 152)
@@ -34,5 +34,7 @@
 #define _TSARMIPS_BUS_H_
 
-#include <mips/locore.h>
+#include <machine/cpu.h>
+#include <sys/mutex.h>
+#include <machine/locore.h>
 
 /*
Index: /trunk/src/sys/arch/tsarmips/tsarmips/machdep.c
===================================================================
--- /trunk/src/sys/arch/tsarmips/tsarmips/machdep.c	(revision 151)
+++ /trunk/src/sys/arch/tsarmips/tsarmips/machdep.c	(revision 152)
@@ -196,5 +196,5 @@
 	 */
 	printf("mips_vector_init");
-	mips_vector_init(NULL);
+	mips_vector_init(NULL, true);
 	printf(" done\n");
 
@@ -474,4 +474,7 @@
 struct splsw mips_splsw;
 
+extern const mips_locore_jumpvec_t mips32_locore_vec;
+mips_locore_jumpvec_t mips_locore_jumpvec;
+
 struct mips_options mips_options = {
         .mips_cpu_id = 0xffffffff,
@@ -496,5 +499,5 @@
  */
 void
-mips_vector_init(const struct splsw *splsw)
+mips_vector_init(const struct splsw *splsw, bool multicpu_p)
 {
 	struct mips_options * const opts = &mips_options;
@@ -523,4 +526,11 @@
 
 	mips_splsw = std_splsw; /* XXX already done in mach_init */
+
+	mips_locore_atomicvec = mips_llsc_locore_atomicvec;
+
+	mips_locore_jumpvec = mips32_locore_vec;
+
+	mips_locoresw = mips32_locoresw;
+	mips_locoresw.lsw_cpu_idle = mips_wait_idle;
 
 	/*
@@ -562,7 +572,4 @@
 	mips_cp0_status_write(mips_cp0_status_read() & ~MIPS_SR_BEV);
 	printf(" done\n");
-	mips_locoresw = mips32_locoresw;
-
-	CPU_IDLE = mips_wait_idle;
 }
 
@@ -580,5 +587,6 @@
 	u_long stack;
 {
-	struct trapframe *tf = l->l_md.md_utf;
+	struct trapframe * const tf = l->l_md.md_utf;
+	struct pcb * const pcb = lwp_getpcb(l);
 
 	memset(tf, 0, sizeof(struct trapframe));
@@ -587,4 +595,5 @@
         tf->tf_regs[_R_T9] = (int)pack->ep_entry & ~3; /* abicall requirement */
         tf->tf_regs[_R_SR] = PSL_USERSET;
+
 
 	/*
@@ -602,7 +611,6 @@
         tf->tf_regs[_R_A3] = (intptr_t)l->l_proc->p_psstr;
 
-	if (l->l_md.md_flags & MDP_FPUSED)
-		fpudiscard_lwp(l);
-	memset(&l->l_addr->u_pcb.pcb_fpregs, 0, sizeof(struct fpreg));
+	fpu_discard();
+	memset(&pcb->pcb_fpregs, 0, sizeof(struct fpreg));
 	l->l_md.md_flags &= ~MDP_FPUSED;
 	l->l_md.md_ss_addr = 0;
Index: /trunk/src/sys/arch/x86/include/cpu.h
===================================================================
--- /trunk/src/sys/arch/x86/include/cpu.h	(revision 151)
+++ /trunk/src/sys/arch/x86/include/cpu.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: cpu.h,v 1.9.10.1 2010/04/21 00:33:45 matt Exp $	*/
+/*	$NetBSD: cpu.h,v 1.9.10.2 2011/05/20 08:11:24 matt Exp $	*/
 
 /*-
@@ -305,7 +305,4 @@
 extern int biosbasemem;
 extern int biosextmem;
-extern unsigned int cpu_feature;
-extern unsigned int cpu_feature2;
-extern unsigned int cpu_feature_padlock;
 extern int cpu;
 extern int cpuid_level;
Index: /trunk/src/sys/arch/x86/include/cpuvar.h
===================================================================
--- /trunk/src/sys/arch/x86/include/cpuvar.h	(revision 151)
+++ /trunk/src/sys/arch/x86/include/cpuvar.h	(revision 152)
@@ -1,3 +1,3 @@
-/* 	$NetBSD: cpuvar.h,v 1.27.16.1 2010/04/21 00:33:45 matt Exp $ */
+/* 	$NetBSD: cpuvar.h,v 1.27.16.2 2011/05/20 08:11:24 matt Exp $ */
 
 /*-
@@ -143,4 +143,9 @@
 extern bool x86_mp_online;
 
+extern uint32_t cpu_feature;
+extern uint32_t cpu_feature2;
+extern uint32_t cpu_feature3;
+extern uint32_t cpu_feature4;
+extern uint32_t cpu_feature_padlock;
 #endif
 
Index: /trunk/src/sys/arch/x86/x86/cpu.c
===================================================================
--- /trunk/src/sys/arch/x86/x86/cpu.c	(revision 151)
+++ /trunk/src/sys/arch/x86/x86/cpu.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: cpu.c,v 1.57.4.3 2009/02/02 20:10:16 snj Exp $	*/
+/*	$NetBSD: cpu.c,v 1.57.4.3.4.1 2011/05/20 08:11:24 matt Exp $	*/
 
 /*-
@@ -63,5 +63,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: cpu.c,v 1.57.4.3 2009/02/02 20:10:16 snj Exp $");
+__KERNEL_RCSID(0, "$NetBSD: cpu.c,v 1.57.4.3.4.1 2011/05/20 08:11:24 matt Exp $");
 
 #include "opt_ddb.h"
@@ -167,4 +167,11 @@
 uint32_t cpus_attached = 0;
 uint32_t cpus_running = 0;
+
+/* CPUID feature flags */
+uint32_t cpu_feature;  /* %edx */
+uint32_t cpu_feature2; /* %ecx */
+uint32_t cpu_feature3; /* extended features - %edx */
+uint32_t cpu_feature4; /* extended features - %ecx */
+uint32_t cpu_feature_padlock; /* VIA PadLock feature flags */
 
 extern char x86_64_doubleflt_stack[];
@@ -970,5 +977,5 @@
 	}
 
-	if (cpu_feature & CPUID_NOX)
+	if (cpu_feature3 & CPUID_NOX)
 		wrmsr(MSR_EFER, rdmsr(MSR_EFER) | EFER_NXE);
 }
Index: /trunk/src/sys/arch/x86/x86/identcpu.c
===================================================================
--- /trunk/src/sys/arch/x86/x86/identcpu.c	(revision 151)
+++ /trunk/src/sys/arch/x86/x86/identcpu.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: identcpu.c,v 1.10.4.2.4.1 2010/04/21 00:33:46 matt Exp $	*/
+/*	$NetBSD: identcpu.c,v 1.10.4.2.4.2 2011/05/20 08:11:24 matt Exp $	*/
 
 /*-
@@ -31,5 +31,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: identcpu.c,v 1.10.4.2.4.1 2010/04/21 00:33:46 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: identcpu.c,v 1.10.4.2.4.2 2011/05/20 08:11:24 matt Exp $");
 
 #include "opt_enhanced_speedstep.h"
@@ -288,6 +288,6 @@
 	if (descs[0] >= 0x80000001) {
 		x86_cpuid(0x80000001, descs);
-		ci->ci_feature3_flags |= descs[3]; /* %edx */
-		ci->ci_feature4_flags = descs[2];  /* %ecx */
+		ci->ci_feature4_flags = descs[2]; /* %ecx */
+		ci->ci_feature3_flags = descs[3]; /* %edx */
 	}
 
@@ -624,8 +624,10 @@
 	}
 
-	if ((cpu_feature | cpu_feature2) == 0) {
+	if (ci == &cpu_info_primary) {
 		/* If first. */
 		cpu_feature = ci->ci_feature_flags;
 		cpu_feature2 = ci->ci_feature2_flags;
+		cpu_feature3 = ci->ci_feature3_flags;
+		cpu_feature4 = ci->ci_feature4_flags;
 		/* Early patch of text segment. */
 #ifndef XEN
@@ -636,4 +638,6 @@
 		cpu_feature &= ci->ci_feature_flags;
 		cpu_feature2 &= ci->ci_feature2_flags;
+		cpu_feature3 &= ci->ci_feature3_flags;
+		cpu_feature4 &= ci->ci_feature4_flags;
 	}
 }
Index: /trunk/src/sys/arch/x86/x86/pmap.c
===================================================================
--- /trunk/src/sys/arch/x86/x86/pmap.c	(revision 151)
+++ /trunk/src/sys/arch/x86/x86/pmap.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: pmap.c,v 1.74.4.1.4.1 2010/04/21 00:33:46 matt Exp $	*/
+/*	$NetBSD: pmap.c,v 1.74.4.1.4.2 2011/05/20 08:11:24 matt Exp $	*/
 
 /*
@@ -155,5 +155,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: pmap.c,v 1.74.4.1.4.1 2010/04/21 00:33:46 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: pmap.c,v 1.74.4.1.4.2 2011/05/20 08:11:24 matt Exp $");
 
 #include "opt_user_ldt.h"
@@ -1075,5 +1075,5 @@
 	     PG_V | PG_k;
 #ifndef XEN
-	if ((cpu_feature & CPUID_NOX) && !(prot & VM_PROT_EXECUTE))
+	if ((cpu_feature3 & CPUID_NOX) && !(prot & VM_PROT_EXECUTE))
 		npte |= PG_NX;
 #endif
@@ -1200,5 +1200,5 @@
 	unsigned long p1i;
 	vaddr_t kva_end;
-	pt_entry_t pg_nx = (cpu_feature & CPUID_NOX ? PG_NX : 0);
+	pt_entry_t pg_nx = (cpu_feature3 & CPUID_NOX ? PG_NX : 0);
 #endif
 
Index: /trunk/src/sys/arch/x86/x86/via_padlock.c
===================================================================
--- /trunk/src/sys/arch/x86/x86/via_padlock.c	(revision 151)
+++ /trunk/src/sys/arch/x86/x86/via_padlock.c	(revision 152)
@@ -1,4 +1,4 @@
 /*	$OpenBSD: via.c,v 1.8 2006/11/17 07:47:56 tom Exp $	*/
-/*	$NetBSD: via_padlock.c,v 1.9 2008/04/16 16:06:52 cegger Exp $ */
+/*	$NetBSD: via_padlock.c,v 1.9.20.1 2011/05/20 08:11:25 matt Exp $ */
 
 /*-
@@ -21,5 +21,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: via_padlock.c,v 1.9 2008/04/16 16:06:52 cegger Exp $");
+__KERNEL_RCSID(0, "$NetBSD: via_padlock.c,v 1.9.20.1 2011/05/20 08:11:25 matt Exp $");
 
 #include "opt_viapadlock.h"
@@ -37,4 +37,5 @@
 
 #include <machine/cpufunc.h>
+#include <machine/cpuvar.h>
 
 #include <opencrypto/cryptodev.h>
Index: /trunk/src/sys/arch/xen/x86/cpu.c
===================================================================
--- /trunk/src/sys/arch/xen/x86/cpu.c	(revision 151)
+++ /trunk/src/sys/arch/xen/x86/cpu.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: cpu.c,v 1.28.4.1 2008/11/13 00:04:07 snj Exp $	*/
+/*	$NetBSD: cpu.c,v 1.28.4.1.4.1 2011/05/20 08:11:25 matt Exp $	*/
 /* NetBSD: cpu.c,v 1.18 2004/02/20 17:35:01 yamt Exp  */
 
@@ -67,5 +67,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: cpu.c,v 1.28.4.1 2008/11/13 00:04:07 snj Exp $");
+__KERNEL_RCSID(0, "$NetBSD: cpu.c,v 1.28.4.1.4.1 2011/05/20 08:11:25 matt Exp $");
 
 #include "opt_ddb.h"
@@ -173,4 +173,11 @@
 uint32_t cpus_attached = 0;
 uint32_t cpus_running = 0;
+
+/* CPUID feature flags */
+uint32_t cpu_feature;  /* %edx */
+uint32_t cpu_feature2; /* %ecx */
+uint32_t cpu_feature3; /* extended features - %edx */
+uint32_t cpu_feature4; /* extended features - %ecx */
+uint32_t cpu_feature_padlock; /* VIA PadLock feature flags */
 
 bool x86_mp_online;
@@ -680,5 +687,4 @@
 	struct cpu_info *ci = (struct cpu_info *)v;
 	int s, i;
-	uint32_t blacklist_features;
 
 #ifdef __x86_64__
@@ -689,7 +695,6 @@
 
 	/* not on Xen... */
-	blacklist_features = ~(CPUID_PGE|CPUID_PSE|CPUID_MTRR|CPUID_FXSR|CPUID_NOX); /* XXX add CPUID_SVM */
-
-	cpu_feature &= blacklist_features;
+	cpu_feature &= ~(CPUID_PGE|CPUID_PSE|CPUID_MTRR|CPUID_FXSR); /* XXX add CPUID_SVM */
+	cpu_feature3 &= ~CPUID_NOX;
 
 	KDASSERT((ci->ci_flags & CPUF_PRESENT) == 0);
Index: /trunk/src/sys/coda/coda.h
===================================================================
--- /trunk/src/sys/coda/coda.h	(revision 151)
+++ /trunk/src/sys/coda/coda.h	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: coda.h,v 1.14 2007/03/04 06:01:11 christos Exp $ */
+/* $NetBSD: coda.h,v 1.14.60.1 2011/05/20 08:11:25 matt Exp $ */
 
 /*
@@ -794,6 +794,6 @@
 struct ViceIoctl {
         void *in, *out;		/* Data to be transferred in, or out */
-        short in_size;          /* Size of input buffer <= 2K */
-        short out_size;         /* Maximum size of output buffer, <= 2K */
+        unsigned short in_size; /* Size of input buffer <= 2K */
+        unsigned short out_size;/* Maximum size of output buffer, <= 2K */
 };
 
Index: /trunk/src/sys/coda/coda_venus.c
===================================================================
--- /trunk/src/sys/coda/coda_venus.c	(revision 151)
+++ /trunk/src/sys/coda/coda_venus.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: coda_venus.c,v 1.25 2007/03/04 06:01:12 christos Exp $	*/
+/*	$NetBSD: coda_venus.c,v 1.25.60.1 2011/05/20 08:11:25 matt Exp $	*/
 
 /*
@@ -33,5 +33,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: coda_venus.c,v 1.25 2007/03/04 06:01:12 christos Exp $");
+__KERNEL_RCSID(0, "$NetBSD: coda_venus.c,v 1.25.60.1 2011/05/20 08:11:25 matt Exp $");
 
 #include <sys/param.h>
@@ -309,5 +309,5 @@
     inp->cmd |= (tmp & IOCPARM_MASK) <<	16;
 
-    if (iap->vi.in_size < 0 || iap->vi.in_size > VC_MAXMSGSIZE) {
+    if (iap->vi.in_size > VC_MAXMSGSIZE || iap->vi.out_size > VC_MAXMSGSIZE) {
 	CODA_FREE(inp, coda_ioctl_size);
 	return (EINVAL);
Index: /trunk/src/sys/coda/coda_vnops.c
===================================================================
--- /trunk/src/sys/coda/coda_vnops.c	(revision 151)
+++ /trunk/src/sys/coda/coda_vnops.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: coda_vnops.c,v 1.68 2008/01/30 09:50:19 ad Exp $	*/
+/*	$NetBSD: coda_vnops.c,v 1.68.28.1 2011/05/20 08:11:25 matt Exp $	*/
 
 /*
@@ -47,5 +47,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: coda_vnops.c,v 1.68 2008/01/30 09:50:19 ad Exp $");
+__KERNEL_RCSID(0, "$NetBSD: coda_vnops.c,v 1.68.28.1 2011/05/20 08:11:25 matt Exp $");
 
 #include <sys/param.h>
@@ -542,5 +542,5 @@
     }
 
-    if (iap->vi.in_size > VC_MAXDATASIZE) {
+    if (iap->vi.in_size > VC_MAXDATASIZE || iap->vi.out_size > VC_MAXDATASIZE) {
 	vrele(tvp);
 	return(EINVAL);
Index: /trunk/src/sys/compat/netbsd32/netbsd32_conv.h
===================================================================
--- /trunk/src/sys/compat/netbsd32/netbsd32_conv.h	(revision 151)
+++ /trunk/src/sys/compat/netbsd32/netbsd32_conv.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: netbsd32_conv.h,v 1.19 2008/06/02 14:12:08 njoly Exp $	*/
+/*	$NetBSD: netbsd32_conv.h,v 1.19.12.1 2010/06/09 18:13:46 matt Exp $	*/
 
 /*
@@ -235,4 +235,5 @@
 	mhp->msg_name = NETBSD32PTR64(mhp32->msg_name);
 	mhp->msg_namelen = mhp32->msg_namelen;
+	mhp->msg_iov = NETBSD32PTR64(mhp32->msg_iov);
 	mhp->msg_iovlen = (size_t)mhp32->msg_iovlen;
 	mhp->msg_control = NETBSD32PTR64(mhp32->msg_control);
Index: /trunk/src/sys/compat/netbsd32/netbsd32_socket.c
===================================================================
--- /trunk/src/sys/compat/netbsd32/netbsd32_socket.c	(revision 151)
+++ /trunk/src/sys/compat/netbsd32/netbsd32_socket.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: netbsd32_socket.c,v 1.33 2008/06/24 11:18:15 ad Exp $	*/
+/*	$NetBSD: netbsd32_socket.c,v 1.33.12.1 2010/06/09 18:13:46 matt Exp $	*/
 
 /*
@@ -28,5 +28,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: netbsd32_socket.c,v 1.33 2008/06/24 11:18:15 ad Exp $");
+__KERNEL_RCSID(0, "$NetBSD: netbsd32_socket.c,v 1.33.12.1 2010/06/09 18:13:46 matt Exp $");
 
 #include <sys/param.h>
@@ -78,4 +78,5 @@
 	} else 
 		iov = aiov;
+
 	msg.msg_flags = SCARG(uap, flags);
 	uiov = (struct iovec *)NETBSD32PTR64(msg.msg_iov);
@@ -238,8 +239,6 @@
 		       sizeof(struct iovec) * (u_int)msg.msg_iovlen, M_IOV,
 		       M_WAITOK);
-	} else if ((u_int)msg.msg_iovlen > 0)
+	} else
 		iov = aiov;
-	else
-		return (EMSGSIZE);
 
 	error = netbsd32_to_iovecin((struct netbsd32_iovec *)msg.msg_iov,
Index: /trunk/src/sys/conf/copyright
===================================================================
--- /trunk/src/sys/conf/copyright	(revision 151)
+++ /trunk/src/sys/conf/copyright	(revision 152)
@@ -1,4 +1,4 @@
 Copyright (c) 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005,
-    2006, 2007, 2008, 2009
+    2006, 2007, 2008, 2009, 2010, 2011
     The NetBSD Foundation, Inc.  All rights reserved.
 Copyright (c) 1982, 1986, 1989, 1991, 1993
Index: /trunk/src/sys/crypto/des/podd.h
===================================================================
--- /trunk/src/sys/crypto/des/podd.h	(revision 151)
+++ /trunk/src/sys/crypto/des/podd.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: podd.h,v 1.1 2000/06/14 19:45:36 thorpej Exp $	*/
+/*	$NetBSD: podd.h,v 1.1.1.1 2000/06/14 19:45:36 thorpej Exp $	*/
 /*	$KAME: podd.h,v 1.3 2000/03/27 04:36:34 sumikawa Exp $	*/
 
